package com.tngtech.jgiven.springtestcase;

import com.tngtech.jgiven.integration.spring.SpringScenarioTest;
import com.tngtech.jgiven.springtestcase.stage.SomeGiven;
import com.tngtech.jgiven.springtestcase.stage.SomeThen;
import com.tngtech.jgiven.springtestcase.stage.SomeWhen;
import com.tngtech.jgiven.springtestcase.testconfig.JGivenTestConfig;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.SpringApplicationConfiguration;
import org.springframework.context.ApplicationContext;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@SpringApplicationConfiguration(classes = JGivenTestConfig.class)
public class JGivenSpringTest extends SpringScenarioTest<SomeGiven, SomeWhen, SomeThen> {

    @Autowired
    private ApplicationContext applicationContext;

    @Test
    public void without_spring_proxies_autowired_works_fine() throws Exception {
        // given
        given().should_say_hello();

        // when
        when().appendWorld_is_called();

        // then
        then().the_message_should_equal_$("Hello World!");
    }
}
