package com.tngtech.jgiven.springtestcase.testconfig;

import com.tngtech.jgiven.integration.spring.EnableJGiven;
import org.springframework.aop.framework.autoproxy.BeanNameAutoProxyCreator;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.EnableAspectJAutoProxy;
import org.springframework.context.annotation.Import;

@EnableJGiven
@ComponentScan({"com.tngtech.jgiven.springtestcase.stage", "com.tngtech.jgiven.springtestcase.service"})
@Import(LoggingAspect.class)
@EnableAspectJAutoProxy
public class JGivenTestConfig {

    @Bean
    public BeanNameAutoProxyCreator jGivenBeanNameAutoProxyCreator() {
        BeanNameAutoProxyCreator beanNameAutoProxyCreator = new BeanNameAutoProxyCreator();
        beanNameAutoProxyCreator.setInterceptorNames("springStepMethodInterceptor");
        return beanNameAutoProxyCreator;
    }

}
